"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var autocomplete_component_1 = require("./autocomplete.component");
var AutoCompleteDirective = (function () {
    function AutoCompleteDirective(view, element, resolver, model) {
        this.view = view;
        this.element = element;
        this.resolver = resolver;
        this.model = model;
        this.minLength = 3;
        this.strings = {};
        this.defaultStrings = {
            noResult: 'Aucun résultat.',
            help: 'Entrez votre recherche (2 caractères min.).'
        };
        element.nativeElement.setAttribute('type', 'hidden');
    }
    AutoCompleteDirective.prototype.ngOnInit = function () {
        var factory = this.resolver.resolveComponentFactory(autocomplete_component_1.AutoCompleteComponent);
        var componentRef = this.view.createComponent(factory);
        componentRef.instance.model = this.model;
        componentRef.instance.map = this.map;
        componentRef.instance.source = this.source;
        componentRef.instance.minLength = this.minLength;
        componentRef.instance.strings = Object.assign({}, this.defaultStrings, this.strings);
        this.element.nativeElement.parentElement.insertBefore(componentRef.location.nativeElement, this.element.nativeElement);
    };
    return AutoCompleteDirective;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Function)
], AutoCompleteDirective.prototype, "source", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Function)
], AutoCompleteDirective.prototype, "map", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], AutoCompleteDirective.prototype, "minLength", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], AutoCompleteDirective.prototype, "strings", void 0);
AutoCompleteDirective = __decorate([
    core_1.Directive({
        selector: '[auto-complete]'
    }),
    __metadata("design:paramtypes", [core_1.ViewContainerRef,
        core_1.ElementRef,
        core_1.ComponentFactoryResolver,
        forms_1.NgControl])
], AutoCompleteDirective);
exports.AutoCompleteDirective = AutoCompleteDirective;
//# sourceMappingURL=autocomplete.directive.js.map