"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var autocomplete_component_1 = require("./autocomplete.component");
var AutoCompleteDirective = (function () {
    function AutoCompleteDirective(view, element, resolver, model) {
        this.view = view;
        this.element = element;
        this.resolver = resolver;
        this.model = model;
        this.minLength = 3;
        this.strings = {};
        this.defaultStrings = {
            noResult: 'Aucun résultat.',
            help: 'Entrez votre recherche (2 caractères min.).'
        };
        element.nativeElement.setAttribute('type', 'hidden');
    }
    AutoCompleteDirective.prototype.ngOnInit = function () {
        var factory = this.resolver.resolveComponentFactory(autocomplete_component_1.AutoCompleteComponent);
        var componentRef = this.view.createComponent(factory);
        componentRef.instance.model = this.model;
        componentRef.instance.map = this.map;
        componentRef.instance.source = this.source;
        componentRef.instance.minLength = this.minLength;
        componentRef.instance.strings = Object.assign({}, this.defaultStrings, this.strings);
        this.element.nativeElement.parentElement.insertBefore(componentRef.location.nativeElement, this.element.nativeElement);
    };
    return AutoCompleteDirective;
}());
AutoCompleteDirective.decorators = [
    { type: core_1.Directive, args: [{
                selector: '[auto-complete]'
            },] },
];
/** @nocollapse */
AutoCompleteDirective.ctorParameters = function () { return [
    { type: core_1.ViewContainerRef, },
    { type: core_1.ElementRef, },
    { type: core_1.ComponentFactoryResolver, },
    { type: forms_1.NgControl, },
]; };
AutoCompleteDirective.propDecorators = {
    'source': [{ type: core_1.Input },],
    'map': [{ type: core_1.Input },],
    'minLength': [{ type: core_1.Input },],
    'strings': [{ type: core_1.Input },],
};
exports.AutoCompleteDirective = AutoCompleteDirective;
//# sourceMappingURL=autocomplete.directive.js.map